#include <bits/stdc++.h>

using namespace std;
int N, M;
char cave[2005][2005];

int cnt_portals;
int cnt_portals_F;
int avail_portals_F[2005][2005];
vector< pair<int, int> > F;

pair<int, int> S;
int min_portal = 2;

bool usedF[2005][2005];
bool usedS[2005][2005];
int dx[4] = { 1, -1, 0,  0 };
int dy[4] = { 0,  0, 1, -1 };
queue< pair<int, int> > q;

bool ok(int x, int y) {
    return (x >= 1 && x <= N && y >= 1 && y <= M && cave[x][y] != '#');
}
int gcd(int a, int b) {
    return (b == 0 ? a : gcd(b, a % b));
}
void dfs1(int x, int y) {
	for (int k = 0; k < 4; ++k) {
		int new_x = x + dx[k];
		int new_y = y + dy[k];
		if (!ok(new_x, new_y) || usedF[new_x][new_y])
			continue;
        usedF[new_x][new_y] = true;
        if (cave[new_x][new_y] == 'S') {
            cout << "1 1" << endl;
            exit(0);
        } else if (cave[new_x][new_y] == 'X') {
            avail_portals_F[new_x][new_y] = 1;
            ++cnt_portals_F;
        } else {
            dfs1(new_x, new_y);
        }
    }
}
void dfs2(int x, int y) {
    for (int k = 0; k < 4; ++k) {
        int new_x = x + dx[k];
        int new_y = y + dy[k];
        if (!ok(new_x, new_y) || usedS[new_x][new_y])
            continue;
        usedS[new_x][new_y] = true;
        if (cave[new_x][new_y] == 'X') {
            min_portal = min(min_portal, avail_portals_F[new_x][new_y]);
        } else {
            dfs2(new_x, new_y);
        }
    }
}
int main( int argc, char *argv[] ) {
	cin.tie(0); cin.sync_with_stdio(0);
	cin >> N >> M;
	for (int x = 1; x <= N; ++x) {
        for (int y = 1; y <= M; ++y) {
            cin >> cave[x][y];
            if (cave[x][y] == 'S') {
                S = make_pair(x, y);
            } else if (cave[x][y] == 'F') {
                F.push_back(make_pair(x, y));
            } else if (cave[x][y] == 'X') {
                ++cnt_portals;
            }
        }
	}
	for (int i = 0; i < (int) F.size(); ++i) {
        dfs1(F[i].first, F[i].second);
	}

	dfs2(S.first, S.second);
	if (min_portal == 2) {   // no portals from S
        cout << "0 1";
	} else if (min_portal == 1) {   // only common with 'F' portals
	    int a = cnt_portals_F - 1;
	    int b = cnt_portals - 1;
        cout << a / gcd(a, b) << " " << b / gcd(a, b) << endl;
	} else {   // there is a separate portal
	    int a = cnt_portals_F;
	    int b = cnt_portals - 1;
	    cout << a / gcd(a, b) << " " << b / gcd(a, b) << endl;
	}
    return 0;
}
